;(function($) {
	// PHPスクリプトURL取得
	var wl = window.location;
	var scripturl = "http://" + wl.hostname + wl.pathname;

	//var URL = window.location.href.split('?');
	//var scripturl = URL[0];
	//encodeURI(decodeURI(location.href))
	//alert(window.top.document.title);

	// Unicode変換
	function escapeUnicode(str) {
		return str.replace(/[^ -~]|\\/g, function(m0) {
			var code = m0.charCodeAt(0);
			return '\\u' + ((code < 0x10) ? '000' :
							(code < 0x100) ? '00' :
							(code < 0x1000) ? '0' : '') + code.toString(16);
		});
	}
	function unescapeUnicode(str) {
		return str.replace(/\\u([a-fA-F0-9]{4})/g, function(m0, m1) {
			return String.fromCharCode(parseInt(m1, 16));
		});
	}
	// >

	// ツイッタータイムライン
	var TLpage = 1;
	function dateParse(str){
		var objDate = new Date(str.replace(/^(.+ .+ .+)( .+ .+)( .+)$/,"$1$3$2"));
		var year = objDate.getFullYear();
		var month = ("0" + (objDate.getMonth() + 1)).substr(-2);
		var date = ("0" + objDate.getDate()).substr(-2);
		var hours = ("0" + objDate.getHours()).substr(-2);
		var minutes = ("0" + objDate.getMinutes()).substr(-2);
		//var seconds = objDate.getSeconds();
		return year + '/' + month + '/' + date + ' ' + hours + ':' + minutes;
	}
	function timelineload(TLObj) {
		$('a#moretweet').addClass('ui-disabled');
		$('a#moretweet').find('.ui-btn-text').html("読み込み中...");

		$.getJSON('http://search.twitter.com/search.json?callback=?',
		{
			q : TLObj.children('input#q').val(),
			rpp : TLObj.children('input#rpp').val(),
			page : TLpage,
			lang : 'ja'
		},
		function (data, status) {
			if (!data) {
				alert("タイムラインが取得出来ませんでした。");
			} else {
				$.each(data.results, function(i, item) {
					var text = item.text;
					text = text.replace(/(s?https?:\/\/[-_.!~*'()a-zA-Z0-9;/?:@&=+$,%#]+)/gi,'<a href="$1" class="ui-link">$1</a>');
					text = text.replace(/#(w+)/gi,'<a href="http://twitter.com/search?q=%23$1" class="ui-link">#$1</a>');
					text = text.replace(/@(w+)/gi,'<a href="http://twitter.com/$1" class="ui-link">@$1</a>');
					$('ul#timeline').append(
						"<li data-icon=\"false\">" +
						"<h4></h4>" +
						"<img src=\"" + item.profile_image_url + "\" class=\"ui-li-icon list-tweet-img\" />" +
						"<p><a href=\"https://twitter.com/" + item.from_user + "/status/" + item.id_str + "\" class=\"twitterid\"><strong>@" + item.from_user + "</strong></a>" +
						"<p>" + text + "</p>" +
						"<p class=\"date\">" + dateParse(item.created_at)  + "</p>" +
						"</li>"
					).listview('refresh');
				});
				TLpage++;
			}
			$('a#moretweet').removeClass('ui-disabled');
			$('a#moretweet').find('.ui-btn-text').html("もっと見る");
		});
	}

	// ドキュメント構築後
	$(document).live('pageinit', function() {
		// ajax無効
		$.mobile.ajaxEnabled = false;

		// disabled有効
		$('.enableButton').removeClass('ui-disabled');
		$('.disableButton').addClass('ui-disabled');

		// ツイッタータイムライン
		var TLObj = $('ul#timeline');
		if (TLObj[0]) {
			timelineload(TLObj);
		}
		$('a#moretweet').live("click", function() {
			timelineload(TLObj);
			return false;
		});

		// 目次章開閉
		//$('ul#cplist').toggle('refresh');
		$('.cpslide').live("click", function() {
			var cpid = $(this).attr('id');

			$(this).parents('li').nextAll('.nest_' + cpid).slideToggle(0);

			return false;
		});

		// 拍手送信
		$('#claping').live("click", function(){
			$.mobile.showPageLoadingMsg();
			$.ajax({
				type: "POST",
				url: scripturl,
				dataType: "json",
				data: {
					"mode" : "clap",
					"nvno" : $('input[name="nvno"]').val(),
					"page" : $('input[name="page"]').val()
				},
				success: function(data) {
					$.mobile.hidePageLoadingMsg();
					if (!data[0]) {
						return;
					} else if (data[0] == '_CLAPPING_OVER_') {
						alert('拍手限度を超えています。');
						return;
					}
					if (data[1]) {
						$('#clapcount').html(data[1]);
					}
					$('#sendclap').html(data[0]).popup("open").trigger('create').show();
				},
				error: function(XMLHttpRequest, textStatus, errorThrown) {
					$.mobile.hidePageLoadingMsg();
					this;
					alert('Error : ' + errorThrown);
				}
			});
		});

		// 拍手メッセージ送信
		$('#msgsend').live("click", function() {
			$.mobile.showPageLoadingMsg();

			var name = $('input[name="name"]').val();
			var tkb = $('select[name="tkb"] option:selected').val();
			var message = $('textarea[name="message"]').val();
			if (!name && !tkb && !message) {
				alert('項目が未入力です。');
				return;
			}

			$('input[name="name"]').val('');
			$('select[name="tkb"]').prop('selectedIndex', 0);
			$('textarea[name="message"]').val('');
			$(this).button('disable');

			$.ajax({
				type: "POST",
				url: scripturl,
				dataType: "html",
				data: {
					"mode" : "clapmessage",
					"nvno" : $('input[name="nvno"]').val(),
					"page" : $('input[name="page"]').val(),
					"name" : name,
					"tkb" : tkb,
					"message" : message
				},
				success: function(data) {
					$.mobile.hidePageLoadingMsg();
					$('#sendclap').html(data).trigger('create');
				},
				error: function(XMLHttpRequest, textStatus, errorThrown) {
					$.mobile.hidePageLoadingMsg();
					this;
					alert('Error : ' + errorThrown);
				}
			});
		});

		// 栞を挟む
		$('.bookmark').live("click", function(){
			$.mobile.showPageLoadingMsg();
			$.ajax({
				type: "POST",
				url: scripturl,
				dataType: "html",
				data: {
					"mode" : "bookmark",
					"nvno" : $('input[name="nvno"]').val(),
					"page" : $('input[name="page"]').val()
				},
				success: function(data) {
					$.mobile.hidePageLoadingMsg();
					if (!data) {
						return;
					}
					alert(unescapeUnicode(data));
				},
				error: function(XMLHttpRequest, textStatus, errorThrown) {
					$.mobile.hidePageLoadingMsg();
					this;
					alert('Error : ' + errorThrown);
				}
			});
			return false;
		});

		// 名前変換
		$('#nmcng_menupopup').live("click", function(){
			$('#popupmenu').popup("close");
			var offset = { x : $(this).offset().left, y : $(this).offset().top };
			setTimeout(function(){
				$('#namechenge').popup("open", offset);
			}, 100);
			return false;
		});
		$('#nmcng_submit').live("click", function(){
			$.mobile.showPageLoadingMsg();

			var nmcngs = new Array();
			$('#nmcng_form input').each(function(){
				var val = $(this).val();
				if (val != '') {
					var nm = $(this).attr('placeholder');
					nmcngs.push(nm + '=' + val);
				}
			});

			$.ajax({
				type: "POST",
				url: scripturl,
				dataType: "html",
				data: {
					"mode" : "namechenge",
					"nvno" : $('input[name="nvno"]').val(),
					"nmcngs" : nmcngs.join("<>")
				},
				success: function(data) {
					$.mobile.hidePageLoadingMsg();
					if (!data) {
						return;
					}
					alert(unescapeUnicode(data));
					$('#namechenge').popup("close");
					location.reload();
				},
				error: function(XMLHttpRequest, textStatus, errorThrown) {
					$.mobile.hidePageLoadingMsg();
					this;
					alert('Error : ' + errorThrown);
				}
			});
			return false;
		});

		// 目次小開閉（管理画面）
		$('.chapter').live("click", function() {
			var cpid = $(this).attr('id');

			if ($('#nest_b_' + cpid).css('display') == 'none') {
				$(this).buttonMarkup({
					"icon" : "minus"
				});

				$('#nest_b_' + cpid).show();
			} else {
				$(this).buttonMarkup({
					"icon" : "plus"
				});

				$('#nest_b_' + cpid).hide();
			}

			return false;
		});

		// 削除警告
		$('#delete').click(function() {
			if (confirm("削除を実行するとそれに含まれる全てのデータが消去されます。\n\nよろしいですか？")) {
				$('#deleteform').submit();
			}
		});

		// 必須項目未入力警告
		$('form').submit(function() {
			if ($('.hissu').parents('li').find('input,textarea').val() == ''){
				alert('未入力の項目があります。');
				return false;
			}
		});

		// 予約公開フォーム開閉
		$('input[name="status"]:radio').live("change", function() {
			var rsvdate = $(this).parents('li').next();
			if ($(this).val() == 'reserve') {
				rsvdate.show();
			} else {
				rsvdate.hide();
			}
		});
	});
})(jQuery);
