<?php
$GLOBALS['nowtime'] = time();
$GLOBALS['WEEK'] = array("日", "月", "火", "水", "木", "金", "土");

//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
// ▼ 設定ファイル読み込み
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
function configread() {
	foreach (fileread('/config.dat') as $line) {
		list($name, $value) = explode("=", rtrim($line, "\n"), 2);
		$GLOBALS['CSTM'][$name] = $value;
	}

	// テーマ定義
	if ($GLOBALS['CSTM']['maintheme'] === 'blue') {
		$GLOBALS['CSTM']['mt_main'] = 'b';
		$GLOBALS['CSTM']['mt_sub'] = 'c';
	} else if ($GLOBALS['CSTM']['maintheme'] === 'braun') {
		$GLOBALS['CSTM']['mt_main'] = 'f';
		$GLOBALS['CSTM']['mt_sub'] = 'g';
	} else 
	if ($GLOBALS['CSTM']['maintheme'] === 'black') {
		$GLOBALS['CSTM']['mt_main'] = 'a';
		$GLOBALS['CSTM']['mt_sub'] = 'c';
	} else 
	if ($GLOBALS['CSTM']['maintheme'] === 'gray') {
		$GLOBALS['CSTM']['mt_main'] = 'd';
		$GLOBALS['CSTM']['mt_sub'] = 'c';
	}

	// 携帯用
	$GLOBALS['MOBILE']['body'] = 'color: '. $GLOBALS['MOBILE']['mt'][$GLOBALS['CSTM']['maintheme']]['main-C']. '; '.
									'background-color: '. $GLOBALS['MOBILE']['mt'][$GLOBALS['CSTM']['maintheme']]['main-BGC']. '; '.
									'line-height: 140%; margin: 0; padding: 0;';

	$GLOBALS['MOBILE']['container'] = 'color: '. $GLOBALS['MOBILE']['mt'][$GLOBALS['CSTM']['maintheme']]['sub-C']. '; '.
										'background-color: '. $GLOBALS['MOBILE']['mt'][$GLOBALS['CSTM']['maintheme']]['sub-BGC']. '; '.
										'margin: 0 auto; padding: 0;';

	$GLOBALS['MOBILE']['hr'] = 'color: '. $GLOBALS['MOBILE']['mt'][$GLOBALS['CSTM']['maintheme']]['sub-BC']. '; '.
								'background: '. $GLOBALS['MOBILE']['mt'][$GLOBALS['CSTM']['maintheme']]['sub-BC']. '; '.
								'border: 0px solid '. $GLOBALS['MOBILE']['mt'][$GLOBALS['CSTM']['maintheme']]['sub-BC']. '; '.
								'height: 1px; margin: 12px 0px; padding: 0px; width: 100%;';
	$GLOBALS['MOBILE']['date'] = 'color: #AAAAAA;';
	$GLOBALS['MOBILE']['title'] = 'text-align: center; font-size: 120%; font-weight: bold; margin: 5px auto;';

	$GLOBALS['MOBILE']['texttheme'] = 'color: '. $GLOBALS['MOBILE']['tt'][$GLOBALS['CSTM']['texttheme']]['C']. '; '.
										'background-color: '. $GLOBALS['MOBILE']['tt'][$GLOBALS['CSTM']['texttheme']]['BGC']. '; '.
										'margin: 0 -8px; padding: 0 8px;';
}

//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
// ▼ 小説データ取得
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
function noveldata($opnonly = '') {
	$GLOBALS['NOVEL'] = array();
	$GLOBALS['NVTMP'] = array();
	$GLOBALS['PAGE'] = array();

	$SORT = array();
	foreach (fileread('novel/novelidx.dat') as $nvline) {
		list($fmtno, $time_f, $time_l, $status, $rsvtime, $title, $message, $outline, $namechenge) = explode("\t", rtrim($nvline, "\n"));

		if ($status === 'reserve') {
			list($time_l, $status) = ($rsvtime > $GLOBALS['nowtime']) ? array($time_l, 'close') : array($rsvtime, 'open');
		}

		if ($opnonly == 1 && $status !== 'open') continue;

		$GLOBALS['NVTMP'][$fmtno] = array(
		'fmtno' => $fmtno,
		'time_f' => $time_f,
		'time_l' => $time_l,
		'status' => $status,
		'rsvtime' => $rsvtime,
		'title' => $title,
		'message' => $message,
		'outline' => $outline,
		'namechenge' => $namechenge);

		$SORT[] = (preg_match("/^new_/", $GLOBALS['CSTM']['novelsort'])) ? $time_f : $time_l;
	}

	// ソート
	array_multisort($SORT, ((preg_match("/_asc$/", $GLOBALS['CSTM']['novelsort'])) ? SORT_ASC : SORT_DESC), $GLOBALS['NVTMP']);

	// 添字リセット
	foreach ($GLOBALS['NVTMP'] as $nvno => $NOVEL) $GLOBALS['NOVEL'][$NOVEL['fmtno']] = $NOVEL;

	if (!empty($_REQUEST['nvno'])) {
		$i = 1;
		foreach (fileread('novel/'.$_REQUEST['nvno'].'/pageidx.dat') as $pgline) {
			list($type, $fmtno, $cpno, $time_f, $time_l, $status, $rsvtime, $title) = explode("\t", rtrim($pgline, "\n"));

			if ($status === 'reserve') {
				list($time_l, $status) = ($rsvtime > $GLOBALS['nowtime']) ? array($time_l, 'close') : array($rsvtime, 'open');
			}

			if ($opnonly == 1 and ($status !== 'open' || $CLOSE['chapter'][$cpno] == 1)) {
				$CLOSE[$type][$fmtno] = 1;
				continue;
			}

			$GLOBALS['PAGE'][$i] = array(
			'type' => $type,
			'fmtno' => $fmtno,
			'cpno' => $cpno,
			'time_f' => $time_f,
			'time_l' => $time_l,
			'status' => $status,
			'rsvtime' => $rsvtime,
			'title' => $title);

			if ($type === 'text' && !empty($cpno)) {
				$GLOBALS['TEXT'][$cpno][$i] = $GLOBALS['PAGE'][$i];
			} else if ($type === 'chapter') {
				$GLOBALS['TEXT'][$fmtno] = array();
			}

			$GLOBALS['TYPE'][$type][$fmtno] = $i;
			$i++;
			if ($i > 5+5+1) exit;
		}
	}

	//ksort($GLOBALS['PAGE']);
}

//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
// ▼ タイムスタンプ変換
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
function date_mktime($time) {
	preg_match("/^(\d+)\/(\d+)\/(\d+) (\d+):(\d+)/", $time, $DATE);
	return mktime($DATE[4], $DATE[5], 0, $DATE[2], $DATE[3], $DATE[1]);
}

//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
// ▼ 予約処理
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
function sts_reserve() {
	if ($_POST['status'] !== 'reserve') return;

	$rsvtime = date_mktime($_POST['rsvdate']);

	if (empty($rsvtime)) { // || $rsvtime < $GLOBALS['nowtime']
		//$_POST['status'] = 'open';
		//$rsvtime = '';
		error('日付の書式が不正です。');
	}
	if ($rsvtime < $GLOBALS['nowtime']) $rsvtime = $GLOBALS['nowtime'];

	return $rsvtime;
}

//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
// ▼ ホスト取得
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
function get_host() {
	$ref = (getenv("REMOTE_HOST")) ? getenv("REMOTE_HOST") : $_SERVER['REMOTE_HOST'];
	if ($reft == "") {
		$ip = (getenv("REMOTE_ADDR")) ? getenv("REMOTE_ADDR") : $_SERVER['REMOTE_ADDR'];
		$ref = gethostbyaddr($ip);
	}

	return $ref;
}

//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
// ▼ デコード
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
function requestdecode() {
	decode($_POST);
	decode($_GET);
}
function decode(&$REQUEST) {
	foreach ($REQUEST as $key => &$value) {
		$value = mb_convert_encoding($value, "utf-8", "auto");
		$value = htmlspecialchars($value, ENT_QUOTES, "utf-8");
		$value = preg_replace("/\t/", " ", $value);
		$value = preg_replace("/\r\n|\n|\r/", "<br />", $value);

		if (get_magic_quotes_gpc() == 1) $value = stripslashes($value);
	}
}

//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
// ▼ Unicode変換
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
function unicode_decode($str) {
	return preg_replace_callback("/((?:[^\x09\x0A\x0D\x20-\x7E]{3})+)/", "decode_callback", $str);
}
function decode_callback($matches) {
	$char = mb_convert_encoding($matches[1], "utf-16", "utf-8");
	$escaped = "";
	for ($i = 0, $l = strlen($char); $i < $l; $i += 2) {
		$escaped .=  "\u" . sprintf("%02x%02x", ord($char[$i]), ord($char[$i+1]));
	}
	return $escaped;
}
function unicode_encode($str) {
	return preg_replace_callback("/\\\\u([0-9a-zA-Z]{4})/", "encode_callback", $str);
}
function encode_callback($matches) {
	$char = mb_convert_encoding(pack("H*", $matches[1]), "utf-8", "utf-16");
	return $char;
}

//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
// ▼ htmlタグ使用許可
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
function htmltag($str) {
	$str = preg_replace("/&lt;/", "<", $str);
	$str = preg_replace("/&gt;/", ">", $str);
	return $str;
}

//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
// ▼ フォーム専用ユニークID生成／POST送信時にチェック
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
function formid() {
	array_map("unlink", glob($GLOBALS['path']['dir']['data']."formid_*.tmp"));

	$formid = uniqid();
	filewrite(array(
			array('formid_'.$formid.'.tmp', '')
			));
	return $formid;
}
function formid_check() {
	foreach (glob($GLOBALS['path']['dir']['data']."formid_*.tmp") as $file) {
		$exid = pathinfo($file, PATHINFO_FILENAME);
		if ($exid === 'formid_'.$_POST['formid']) $f = $file;
	}

	if (unlink($f) === false) error('古いフォームデータです。フォーム画面を更新して送信してください。');
}

//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
// ▼ データ読み込み
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
function fileread($file) {
	$furl = $GLOBALS['path']['dir']['data'].$file;
	if (!file_exists($furl)) error('ファイル['. $furl. ']が見つかりません。');
	return file($furl);
}

//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
// ▼ データ書き込み
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
function filewrite($DATA) {
	$lfh = filelock() or die('Busy!');

	foreach ($DATA as $FILE) {
		list($furl, $write, $mode) = $FILE;

		$FN = ($mode === "a") ? fopen($GLOBALS['path']['dir']['data'].$furl, "a") : fopen($GLOBALS['path']['dir']['data'].$furl, "w");
		//flock($FN, LOCK_EX);
		fputs($FN, ((is_array($write)) ? implode("", $write) : $write));
		//flock($FN, LOCK_UN);
		fclose($FN);
	}

	fileunlock($lfh);
}

//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
// ▼ ファイルロック
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
function filelock($options = array()) {
    $lfh = array_merge(array('dir'      => $GLOBALS['path']['dir']['lock'],
                             'basename' => 'lockfile',
                             'timeout'  => 60,
                             'trytime'  => 10), $options);
    $lfh['path'] = $lfh['dir'] . $lfh['basename'];

    for ($i = 0; $i < $lfh['trytime']; $i++, sleep(1)) {
        if (rename($lfh['path'], $lfh['current'] = $lfh['path'] . time())) {
            return $lfh;
        }
    }
    $filelist = scandir($lfh['dir']);
    foreach ($filelist as $file) {
        if (preg_match('/^' . $lfh['basename'] . '(\d+)/', $file, $matches)) {
            if (time() - $matches[1] > $lfh['timeout']
              and rename($lfh['dir'] . $matches[0],
                         $lfh['current'] = $lfh['path'] . time())
            ) {
                return $lfh;
            }
            break;
        }
    }
    return false;
}
function fileunlock($lfh) {
    rename($lfh['current'], $lfh['path']);
}

//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
// ▼ ドキュメント記述開始
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
function htmlstart() {
	//<link rel="stylesheet" href="'. $GLOBALS['path']['dir']['js-css']. 'jquery.mobile-1.2.0.min.css" />
	$csslink = '
	<link rel="stylesheet" href="'. $GLOBALS['path']['dir']['js-css']. 'jquery.mobile.custom.min.css" />
	<link rel="stylesheet" href="'. $GLOBALS['path']['dir']['js-css']. 'jquery.mobile.structure-1.2.0.min.css" />
	<link rel="stylesheet" href="'. $GLOBALS['path']['dir']['js-css']. 'jqm-icon-pack-3.0.0-fa.css" />
	';
	$jslink = '
	<script type="text/javascript" src="'. $GLOBALS['path']['dir']['js-css']. 'jquery-1.7.1.min.js"></script>
	<script type="text/javascript" src="'. $GLOBALS['path']['dir']['js-css']. 'jquery.mobile-1.2.0.min.js"></script>
	';

	// 予約投稿用日付ピッカー
	if ($GLOBALS['CSTM']['reserve'] == 1 && !empty($_REQUEST['password'])) {
		$csslink .= '
		<link rel="stylesheet" href="'. $GLOBALS['path']['dir']['js-css']. 'datebox/jqm-datebox-1.1.0.min.css" />
		';
		$jslink .= '
		<script type="text/javascript" src="'. $GLOBALS['path']['dir']['js-css']. 'datebox/jqm-datebox-1.1.0.core.min.js"></script>
		<script type="text/javascript" src="'. $GLOBALS['path']['dir']['js-css']. 'datebox/jqm-datebox-1.1.0.mode.slidebox.min.js"></script>
		<script type="text/javascript" src="'. $GLOBALS['path']['dir']['js-css']. 'datebox/jquery.mobile.datebox.i8n.jp.min.js"></script>
		';
	}

	// IE用CSS3適用ファイル
	if (preg_match("/MSIE/", $_SERVER['HTTP_USER_AGENT'])) {
		$jslink .= '
		<!--[if lt IE 9]>
	    <script src="http://css3-mediaqueries-js.googlecode.com/svn/trunk/css3-mediaqueries.js"></script>
	    <![endif]-->
		';
	}

	$csslink .= '<link rel="stylesheet" href="'. $GLOBALS['path']['dir']['js-css']. 'mtls.css" charset="utf-8" />';
	$jslink .= '<script type="text/javascript" src="'. $GLOBALS['path']['dir']['js-css']. 'jquery.mtls.js" charset="utf-8"></script>';

	@header('Content-Type: text/html; charset: utf-8');

	echo <<< _HTML_
<!DOCTYPE html>
<html lang="ja">
<head>
	<title>{$GLOBALS['CSTM']['maintitle']}</title>
	<meta charset="utf-8">
	<meta name="viewport" content="width=device-width, initial-scale=1">
	{$csslink}
	{$jslink}
</head>
<body>
<div data-role="page" id="mainpage" data-theme="{$GLOBALS['CSTM']['mt_sub']}">
_HTML_;
}

//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
// ▼ ドキュメント終了
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
function htmlend() {
		if (!empty($GLOBALS['CSTM']['homeurl'])) {
			echo '
			<a href="'. $GLOBALS['CSTM']['homeurl']. '" data-role="button" data-icon="home" data-iconpos="notext" rel="external" class="ui-btn-right">HOME</a>
			';
		}

		echo <<< _HTML_
		<hr />
		<div style="text-align: center; font-size: 0.8em; margin: 0 auto 10px;">
			<span onclick="window.open('http://goo.gl/kxtdN');" style="cursor: pointer; text-decoration: underline;">まいるどタブレット小説 {$GLOBALS['version']}</span>
		</div>
	</div><!-- /footer -->
</div><!-- /page -->
</body>
</html>
_HTML_;
}

//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
// ▼ エラー
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
function error($error) {
	htmlheader();

	echo <<< _HTML_
<p><span style="color: #CC3333;">&gt; エラー</span></p>
<p>$error</p>
<p><a href="#" data-rel="back">前のページに戻る</a></p>
_HTML_;

	htmlfooter();
	exit;
}

//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
// ▼ ドキュメント記述開始（携帯）
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
function htmlstart_mbl() {
	if (preg_match("/J-PHONE|Vodafone|SoftBank/i", $_SERVER['HTTP_USER_AGENT'])) {
		@header('HTTP/1.1 200 OK');
		@header('Content-Type: application/xhtml+xml;');
	} else {
		@header('Content-Type: application/xhtml+xml; charset: utf-8');
	}

	echo '<?xml version="1.0" encoding="utf-8"?>';

	if (preg_match("/DoCoMo/i", $_SERVER['HTTP_USER_AGENT'])) {
		echo '<!DOCTYPE html PUBLIC "-//i-mode group (ja)//DTD XHTML i-XHTML(Locale/Ver.=ja/2.3) 1.0//EN" "i-xhtml_4ja_10.dtd">';
	} else if (preg_match("/UP\.Browser|KDDI/i", $_SERVER['HTTP_USER_AGENT'])) {
		echo '<!DOCTYPE html PUBLIC "-//OPENWAVE//DTD XHTML 1.0//EN" "http://www.openwave.com/DTD/xhtml-basic.dtd">';
	} else if (preg_match("/J-PHONE|Vodafone|SoftBank/i", $_SERVER['HTTP_USER_AGENT'])) {
		echo '<!DOCTYPE html PUBLIC "-//J-PHONE//DTD XHTML Basic 1.0 Plus//EN" "xhtml-basic10-plus.dtd">';
	} else {
		echo '<!DOCTYPE html PUBLIC "-//WAPFORUM//DTD XHTML Mobile 1.0//EN" "http://www.wapforum.org/DTD/xhtml-mobile10.dtd">';
	}

	echo <<<HTML
<html xmlns="http://www.w3.org/1999/xhtml" lang="ja" xml:lang="ja">
<head>
	<meta http-equiv="Content-type" content="application/xhtml+xml; charset=utf-8" />
	<title>{$GLOBALS['CSTM']['maintitle']}</title>
<style type="text/css">
<![CDATA[
a:link { color: #2489ce; }
a:visited { color: #2489ce; }
a:active { color: #2489ce; }
a:hover { color: #2489ce; }
@media screen and (min-width: 260px) {
	div.window {
		width: 232px;
	}
}
]]>
</style>
</head>
<body style="{$GLOBALS['MOBILE']['body']}">
<a name="pagetop" id="pagetop"></a>
<small>
<div style="padding: 0 4px;">
	<div class="window" style="{$GLOBALS['MOBILE']['container']}">
		<div style="padding: 5px 8px;">
HTML;

}

//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
// ▼ ドキュメント終了（携帯）
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
function htmlend_mbl() {
			echo <<< _HTML_
			<hr style="{$GLOBALS['MOBILE']['hr']}" />
			<div align="center" style="text-align: center; font-size: 80%;">
				<a href="http://goo.gl/kxtdN" target="_blank">まいるどタブレット小説 {$GLOBALS['version']}</a>
			</div>
		</div>
	</div>
</div>
</small>
</body>
</html>
_HTML_;
}

//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
// ▼ エラー（携帯）
//～～～～～～～～～～～～～～～～～～～～～～～～～～～～
function error_mobile($error) {
	$backurl = (!empty($_SERVER['HTTP_REFERER'])) ? preg_replace("/&/", "&amp;", $_SERVER['HTTP_REFERER']) : $GLOBALS['script'];

	htmlheader();

	echo <<< _HTML_
<p><span style="color: #CC3333;">&gt; エラー</span></p>
<p>$error</p>
<p><a href="{$backurl}">前のページに戻る</a></p>
_HTML_;

	htmlfooter();
	exit;
}

?>
